//This has just been cut from my code, Delphi 6, it will not compile but shows how to do it
//questions/suggestions are welcome
//jacka@bre.co.uk
//
//Angus Jack, please note Angus is my Christian name:) 



function TForm1.PaintTheBitMap(MemoryStream : TMemoryStream): Boolean;	//draws a bitmap to a TImage that can be dealt with in a normal manner
var
IntI, IntJ : Integer;
RByte, GByte, BByte : Byte;
BitMap : TBitmap;
Row : pRGBTripleArray;		    //**Important use this** 
BitMapFileName : String;


begin

//Begin One way to do it, this has a noticible impact on a modern machine
{   SetLength(ArrayRGB, FrameW, FrameH);   //alternative processor inefficient method
   IntK := Trunc(DataOffset/3);
   MemoryStream.Seek(0, soFromBeginning);//make sure we are at the beginning of the stream

   for IntJ := FrameH -1 downto 0 do
   begin
      for IntI := 0 to FrameW -1 do
      begin
      MemoryStream.ReadBuffer(RByte,1);
      MemoryStream.ReadBuffer(GByte,1);
      MemoryStream.ReadBuffer(BByte,1);

      stPixelColour := '$00' + IntToHex(Rbyte,2) + IntToHex(Gbyte,2) + IntToHex(Bbyte,2);  //concantinate the RGB value and set intensity to $00 (highest)      PixelColour := StringToColor(stPixelColour);  //make the colour $00RRGGBB for each pixel
      PixelColour := StringToColor(stPixelColour);
      Image1.Canvas.Pixels[IntI,IntJ] := PixelColour;
      end;
   end;}

 //End One way to do it


 //Start ScanLine Method of doing it
   Result := False;
   MemoryStream.Seek(0, soFromBeginning);     // make sure we at the beginning of the stream, created elsewhere in the same manner as any other object, create free etc
   BitMap := TBitmap.Create;                  //Create a bitmap
   try
      BitMap.PixelFormat := pf24bit;	      //Set the bitmap to 24bit keep this on the top before other properties are set	
      BitMap.Height := FrameH ;               //set the height
      BitMap.Width := FrameW ;                //ditto width

      For IntJ :=  BitMap.Height - 1 downto 0 do   //for all the rows in the bitmap do
      begin
      Row := BitMap.ScanLine[IntJ];                //assign the first line of the bitmap to Row of type pRGBTripleArray
         For IntI := 0 to BitMap.Width  - 1 do     //I got some hassle about this at the meeting but this is because I knew that my users would run this app in the background (for big files) so they need access to the system
         begin
         Application.ProcessMessages;		   //ditto above
            with Row[IntI] do			   //for each ScanLine, stuff the colour bytes BGR in that order 
            begin
            MemoryStream.ReadBuffer(RByte,1);	   //read one byte from the stream and move on one byte
            rgbtRed := BByte;			   //pass the byte value to rgbtRed part of pRGBTriple (tagRGBTriple)
            MemoryStream.ReadBuffer(GByte,1);
            rgbtGreen := GByte;			   //dble ditto
            MemoryStream.ReadBuffer(BByte,1);
            rgbtBlue := RByte;			   //dble ditto
            end;
         end;
      end;

   Image1.Picture.Graphic := BitMap;		   //put the Bitmap on the Image (can be hidden does not need a screen)

//Start adding the time stamp to the image

   DateTimeToString(StringStamp, 'dd/mm/yyyy hh:nn:ss.zzz', TimeFrameTime); //sort out the format of the time stamp
   Image1.Picture.Bitmap.Canvas.TextOut( 5, 5, StringStamp  + ' ');	    //put it at 5,5 from the top left corner
   BitmapFileName := NewFileName(OpenDialog1.FileName, 'bmp' ,FrameNumber); //set a file name (particular to my app)
   Image1.Picture.SaveToFile(BitMapFileName);				    //Save the image to file with the name of choice
   finally
   BitMap.Free;								    //Free the Bitmap
   Result := True;
   end;

end;
